=== added file 'mpregen'
--- mpregen	1970-01-01 00:00:00 +0000
+++ mpregen	2007-04-11 06:39:09 +0000
@@ -0,0 +1,61 @@
+#!/usr/bin/env python2.4
+from itertools import izip
+import sys
+import time
+
+from bzrlib.workingtree import WorkingTree
+
+from multiparent import MultiVersionedFile
+single_parent = False
+if len(sys.argv) > 1 and len(sys.argv) < 4:
+    wt, path = WorkingTree.open_containing(sys.argv[-1])
+    if len(sys.argv) == 3:
+        assert sys.argv[1] == '--single'
+        single_parent = True
+else:
+    print >> sys.stderr, 'Usage: mpknit [--single] FILENAME'
+    sys.exit(3)
+
+bt = wt.branch.repository.revision_tree(wt.last_revision())
+file_id = wt.path2id(path)
+file_weave = bt.get_weave(file_id)
+file_weave.enable_cache()
+vf = MultiVersionedFile()
+ancestry = set(file_weave.get_ancestry([bt.inventory[file_id].revision]))
+files = dict(izip(ancestry, file_weave.get_line_list(ancestry)))
+while len(ancestry) > 0:
+    added = set()
+    for revision in ancestry:
+        parents = file_weave.get_parents(revision)
+        if [p for p in parents if p not in vf._diffs] != []:
+            continue
+        lines = files[revision]
+        vf.add_version(lines, revision, parents)
+        added.add(revision)
+    ancestry = [r for r in ancestry if r not in added]
+vf.clear_cache()
+if False:
+    for revision_id in file_weave.get_ancestry(
+        [bt.inventory[file_id].revision]):
+        if vf.get_line_list([revision_id])[0] != \
+            file_weave.get_lines(revision_id):
+            open(revision_id + '.old', 'wb').writelines(
+                file_weave.get_lines(revision_id))
+            open(revision_id + '.new', 'wb').writelines(
+                vf.get_line_list(revision_id)[0])
+if True:
+    revisions = file_weave.get_ancestry(
+            [bt.inventory[file_id].revision])[-1:]
+    from bzrlib.lsprof import profile
+    ret, stats = profile(vf.get_line_list, revisions)
+    stats.sort()
+    stats.pprint()
+    start = time.clock()
+    for x in range(1000):
+        vf.clear_cache()
+        vf.get_line_list(revisions)
+    print time.clock() - start
+    start = time.clock()
+    for x in range(1000):
+        file_weave.get_line_list(revisions)
+    print time.clock() - start

=== modified file 'multiparent/__init__.py'
--- multiparent/__init__.py	2007-04-11 04:18:39 +0000
+++ multiparent/__init__.py	2007-04-11 06:39:09 +0000
@@ -161,14 +161,35 @@
 class MultiVersionedFile(object):
     """VersionedFile skeleton for MultiParent"""
 
-    def __init__(self):
+    def __init__(self, snapshot_interval=25):
         self._diffs = {}
         self._lines = {}
         self._parents = {}
+        self._snapshots = {}
+        self.snapshot_interval = snapshot_interval
+
+    def do_snapshot(self, version_id, parent_ids):
+        if len(parent_ids) == 0:
+            return False
+        counter = 0
+        while counter < self.snapshot_interval:
+            if len(parent_ids) == 0:
+                return False
+            version_id = parent_ids[0]
+            if self._snapshots[version_id]:
+                return False
+            counter += 1
+            parent_ids = self._parents[version_id]
+        return True
 
     def add_version(self, lines, version_id, parent_ids):
-        parent_lines = [self._lines[p] for p in parent_ids]
-        diff = MultiParent.from_lines(lines, parent_lines)
+        if self.do_snapshot(version_id, parent_ids):
+            self._snapshots[version_id] = True
+            diff = MultiParent([NewText(lines)])
+        else:
+            self._snapshots[version_id] = False
+            parent_lines = [self._lines[p] for p in parent_ids]
+            diff = MultiParent.from_lines(lines, parent_lines)
         self.add_diff(diff, version_id, parent_ids)
         self._lines[version_id] = lines
 

